
#include <stdio.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#include "usart.h"

void init_USART(int8_t interrupt_enable)
{
	UBRRH = 0;					
	UBRRL = 103;									//9600 baud
	UCSRB = _BV(TXEN) | _BV(RXEN);	
	UCSRC = _BV(URSEL) | _BV(UCSZ1) | _BV(UCSZ0);	//8bit 
	if (interrupt_enable)
		UCSRB |= (1 << RXCIE); 
}

void usart_send(uint8_t data)
{
	loop_until_bit_is_set(UCSRA, UDRE);
	UDR = data;
}

uint8_t usart_recv()
{
	uint8_t data;
	loop_until_bit_is_set(UCSRA, RXC);
	data = UDR;
	return data;
}


uint8_t pack_move(uint8_t y1, uint8_t y2)
{
	uint8_t move;
	
	move = y1;
	move = move << 4;
	move |= y2 & 0x0F;
	
	return move;
}

void unpack_move(uint8_t move, uint8_t *y1, uint8_t *y2)
{
	
	*y1 = (move & 0xF0) >> 4;
	*y2 = move & 0x0F;
}



